<template xmlns:v-slot="http://www.w3.org/1999/XSL/Transform">
    <v-layout column align-center justify-center>

        <v-card width="90%">
            <v-card-title>
                <v-layout row class="fab-container">

                    <v-btn
                        color="green"
                        dark
                        small
                        absolute
                        top
                        left
                        fab
                        @click="add"
                    >
                        <v-icon light>add</v-icon>
                    </v-btn>

                </v-layout>

                <v-layout column>
                    <v-layout wrap>
                        <v-flex right class="pl-1 p-r1" xs12 sm12 md12>
                            <v-layout wrap>
                                <v-flex xs12 sm12 md4>
                                    <v-layout row>
                                        <h5 class="ma-1 mr-3">
                                            از:
                                        </h5>
                                        <date-picker @input="setStartTime" color="#b71c1c" type="datetime"
                                                     :value="filter.start_time"></date-picker>
                                    </v-layout>
                                </v-flex>
                                <v-flex xs12 sm12 md4>
                                    <v-layout row>
                                        <h5 class="ma-1 mr-3">
                                            تا:
                                        </h5>
                                        <date-picker @input="setEndTime" color="#b71c1c" type="datetime"
                                                     :value="filter.end_time"></date-picker>
                                    </v-layout>
                                </v-flex>
                            </v-layout>
                        </v-flex>
                    </v-layout>
                    <v-layout center class="ma-2" row>
                        <v-btn
                            color="green"
                            dark
                            small
                            top
                            center
                            @click="readData"
                        >
                            اعمال فیلتر ها
                        </v-btn>

                        <v-btn
                            color="error"
                            dark
                            small
                            top
                            center
                            @click="removeFilter"
                        >
                            حذف فیلتر ها
                        </v-btn>
                    </v-layout>
                </v-layout>
            </v-card-title>
        </v-card>
        <v-card class="mt-2" width="90%">
            <v-card-title>
                <v-layout column>

                    <v-data-table
                        :headers="headers"
                        :items="allData"
                        hide-actions
                    >
                        <template
                            slot="headerCell"
                            slot-scope="{ header }"
                        >
                    <span class="subheading font-weight-light text-success text--darken-3"
                          v-text="header.text"
                    ></span>

                        </template>
                        <template v-slot:no-data>
                            <div v-show="allDataLoading === true" class="justify-center layout px-0">
                                <v-progress-circular indeterminate color="primary"
                                                     align-center justify-center row></v-progress-circular>
                            </div>

                            <div v-show="allData.length === 0 && allDataLoading === false"
                                 class="justify-center layout px-0">
                                {{'داده ای وجود ندارد'}}
                            </div>

                        </template>
                        <template
                            slot="items"
                            slot-scope="{ item }"
                        >
                            <td>{{ item.title}}</td>
                            <td>{{ item.content}}</td>
                            <td>{{ item.for_carriers === 0 ? 'خیر' : 'آره'}}</td>
                            <td>{{ item.for_drivers === 0 ? 'خیر' : 'آره'}}</td>
                            <td>{{ item.for_cargo_owners === 0 ? 'خیر' : 'آره'}}</td>
                            <td>{{ item.for_marketers === 0 ? 'خیر' : 'آره'}}</td>
                            <td>{{ convertDateTimeToJalali(item.created_at)}}</td>

                            <td class="justify-center layout px-0">
                                <v-icon
                                    small
                                    class="mr-2"
                                    @click="edit(item)"
                                >
                                    edit
                                </v-icon>

                                <!--<v-icon-->
                                <!--small-->
                                <!--@click="deleteItem(item)"-->
                                <!--&gt;-->
                                <!--delete-->
                                <!--</v-icon>-->
                            </td>
                            <td>
                                <v-btn small class="mr-2" color="error" @click="activateItem(item)">
                                    {{ item.status === 0 ? 'فعال سازی' : 'غیرفعال سازی'}}
                                </v-btn>
                            </td>
                        </template>
                    </v-data-table>
                </v-layout>
            </v-card-title>
        </v-card>
        <v-dialog v-model="AddDialog" persistent max-width="800px" max-height="700px">
            <v-card>
                <v-card-text>
                    <v-container grid-list-md>
                        <v-layout wrap>
                            <v-flex xs12 md4 sm4>
                                <v-text-field @change="setTitle" v-model="selectedItem.title"
                                              label="عنوان"></v-text-field>
                            </v-flex>
                            <v-flex xs12 md4 sm4>
                                <v-text-field @change="setContent" v-model="selectedItem.content"
                                              label="متن"></v-text-field>
                            </v-flex>

                            <v-flex xs12 md4 sm4>
                                <v-checkbox @change="setForCarrier" v-model="selectedItem.for_carriers"
                                            label="برای باربری ها"></v-checkbox>
                            </v-flex>
                            <v-flex xs12 md4 sm4>
                                <v-checkbox @change="setForDriver" v-model="selectedItem.for_drivers"
                                            label="برای رانندگان"></v-checkbox>
                            </v-flex>
                            <v-flex xs12 md4 sm4>
                                <v-checkbox @change="setForCargoOwner" v-model="selectedItem.for_cargo_owners"
                                            label="برای صاحبین بار"></v-checkbox>
                            </v-flex>
                            <v-flex xs12 md4 sm4>
                                <v-checkbox @change="setForMarketer" v-model="selectedItem.for_marketers"
                                            label="برای بازاریابان"></v-checkbox>
                            </v-flex>
                        </v-layout>
                    </v-container>
                </v-card-text>

                <v-card-actions>
                    <v-spacer></v-spacer>
                    <v-btn color="blue darken-1" flat @click="hideAddDialog">لغو</v-btn>
                    <v-btn color="blue darken-1" flat @click="add_Edit">
                        <v-progress-circular v-show="this.pending === true" indeterminate
                                             color="white"></v-progress-circular>
                        <div v-show="this.pending === false">ذخیره</div>
                    </v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>
        <v-dialog
            v-model="DeleteDialog"
            width="500"
        >

            <v-card>
                <v-card-text>
                    آیا مطمئن هستید که می خواهید این پیام را حذف کنید؟
                </v-card-text>

                <v-card-actions>
                    <v-spacer></v-spacer>
                    <v-btn color="blue darken-1" flat @click="hideDeleteDialog">لغو</v-btn>
                    <v-btn color="blue darken-1" flat @click="deleteOne">
                        <v-progress-circular v-show="this.pending === true" indeterminate
                                             color="white"></v-progress-circular>
                        <div v-show="this.pending === false">حذف</div>
                    </v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>

        <v-dialog
            v-model="WaitDialog"
            dark
            hide-overlay
            persistent
            width="300"
        >
            <v-card
                color="primary"
                dark
            >
                <v-card-text>
                    لطفا منتظر بمانید
                    <v-progress-linear
                        indeterminate
                        color="white"
                        class="mb-0"
                    ></v-progress-linear>
                </v-card-text>
            </v-card>
        </v-dialog>
    </v-layout>
</template>
<script>
    import {mapActions, mapMutations, mapState} from "vuex";
    import {convertDateTimeToJalali} from '../../data/convertors'

    export default {
        name: "message",
        methods: {
            ...mapMutations({
                setTitle: 'message/setTitle',
                setContent: 'message/setContent',
                setStatus: 'message/setStatus',
                setForMarketer: 'message/setForMarketer',
                setForCarrier: 'message/setForCarrier',
                setForDriver: 'message/setForDriver',
                setForCargoOwner: 'message/setForCargoOwner',
                setSelectedItem: 'message/setSelectedItem',
                showAddDialog: 'message/showAddDialog',
                hideAddDialog: 'message/hideAddDialog',
                showDeleteDialog: 'message/showDeleteDialog',
                hideDeleteDialog: 'message/hideDeleteDialog',
                setStartTime: 'message/setStartTime',
                setEndTime: 'message/setEndTime',
            }),
            ...mapActions({
                removeFilter: 'message/removeFilter',
                readData: 'message/readData',
                addOrEdit: 'message/addOrEdit',
                deleteOne: 'message/deleteOne',
                activate: 'message/activate',

            }),

            add() {
                this.setSelectedItem({
                    id: null,
                    title: null,
                    content: null,
                    sent_at: null,
                    status: null,
                    for_carriers: null,
                    for_drivers: null,
                    for_cargo_owners: null,
                    for_marketers: null,
                    operator_id: null
                });
                this.showAddDialog();
            },
            edit(item) {
                this.setSelectedItem({
                    id: item.id,
                    title: item.title,
                    content: item.content,
                    sent_at: item.sent_at,
                    status: item.status,
                    for_carriers: item.for_carriers,
                    for_drivers: item.for_drivers,
                    for_cargo_owners: item.for_cargo_owners,
                    for_marketers: item.for_marketers,
                    operator_id: item.operator_id
                });
                this.showAddDialog();
            },
            add_Edit() {
                this.addOrEdit();
            },

            deleteItem(item) {
                this.setSelectedItem(item);
                this.showDeleteDialog()
            },

            activateItem(item) {
                this.setSelectedItem(item);
                this.activate(item)
            },
        },
        computed: {
            ...mapState({
                allData: state => state.message.allData,
                AddDialog: state => state.message.AddDialog,
                DeleteDialog: state => state.message.DeleteDialog,
                selectedItem: state => state.message.selectedItem,
                pending: state => state.message.pending,
                allDataLoading: state => state.message.allDataLoading,
                WaitDialog: state => state.message.WaitDialog,
                filter: state => state.message.filter,

            })
        },
        mounted() {
            this.readData();
        },
        data() {
            return {
                headers: [
                    {text: 'عنوان', align: 'right', value: 'title'},
                    {text: 'متن', align: 'right', value: 'content'},
                    {text: 'برای باربری ها', align: 'right', value: 'for_carriers'},
                    {text: 'برای راننده ها', align: 'right', value: 'for_drivers'},
                    {text: 'برای صاحبین بار', align: 'right', value: 'for_cargo_owners'},
                    {text: 'برای بازاریابان', align: 'right', value: 'for_marketers'},
                    {text: 'زمان ارسال', align: 'right', value: 'created_at'},
                ],
                convertDateTimeToJalali,
            }
        },

    }
</script>
<style scoped>
</style>
